<template>
  <div class="pa-3 white">
    <m-filter @search="handleSearch" />
    <m-table
      class="mt-3"
      :loading="loading"
      :headers="headers"
      :items="items"
      :total="total"
      :page-info="pageInfo"
      :disable-sort="true"
      :show-select="false"
      :is-tools="false"
      @edit="handleEdit"
      @delete="handleDelete"
      @pageHandleChange="pageHandleChange"
      @sort="handleSort"
    >
      <template #status="{ item }">
        <v-chip
          :color="item.status ? 'success' : 'error'"
          small
        >
          {{ item.status ? '已启用' : '已禁用'}}
        </v-chip>
      </template>
      <template #navBtn>
        <v-btn class="elevation-5 mr-2 buttons" rounded color="primary" @click="handleAdd">
          <v-icon left>mdi-plus</v-icon>
          新增标准
        </v-btn>
      </template>
    </m-table>

    <m-dialog :title="title" :visible.sync="show" @submit="handleSubmit">
      <edit-page v-if="show" ref="edit" :item-data="itemData" v-loading="overlay"></edit-page>
    </m-dialog>
  </div>
</template>

<script>
import MFilter from '../components/Filter'
import MTable from '@/components/List/table.vue'
import MDialog from '@/components/Dialog'
import EditPage from './components/edit'
import { api } from '@/api/dataGovernance'

export default {
  name: 'data-standard',
  components: {
    MFilter,
    MTable,
    MDialog,
    EditPage
  },
  data () {
    return {
      loading: false,
      overlay: false,
      show: false,
      queryData: {
        name_zh: null
      },
      headers: [
        { text: '名称', value: 'name_zh' },
        { text: '分类', value: 'category' },
        { text: '适用范围', value: 'scope' },
        { text: '引用数量', value: 'number', align: 'center' },
        { text: '描述', value: 'describe' },
        { text: '状态', value: 'status' },
        { text: '创建时间', value: 'create_time' },
        { text: '操作', value: 'actions' }
      ],
      itemData: {},
      items: [],
      orders: [],
      pageInfo: {
        size: 10,
        current: 1
      },
      total: 0
    }
  },
  computed: {
    title () {
      return `${Object.keys(this.itemData).length ? '编辑' : '新增'}数据标准`
    }
  },
  created () {
    this.init()
  },
  methods: {
    async init () {
      this.loading = true
      try {
        const { data } = await api.dataStandardList({
          ...this.pageInfo,
          ...this.queryData
        })
        this.items = data.records
        this.total = data.total
      } catch (error) {
        this.$snackbar.error(error)
      } finally {
        this.loading = false
      }
    },
    handleSearch (val) {
      Object.assign(this.queryData, val)
      this.pageInfo.current = 1
      this.init()
    },
    handleAdd () {
      this.itemData = {}
      this.show = true
    },
    async handleEdit (item) {
      try {
        const { data } = await api.dataStandardDetails({ id: item.id })

        this.itemData = data
        this.show = true
      } catch (error) {
        this.$snackbar.error(error)
      }
    },
    handleDelete (ids) {
      if (Array.isArray(ids) && !ids.length) return this.$snackbar.warning('请选择要删除的选项')
      this.$confirm('提示', '是否删除该选项')
        .then(async () => {
          try {
            await api.graphDataDelete({ id: ids })
            this.$snackbar.success('删除成功')
            this.init()
          } catch (error) {
            this.$snackbar.error('删除失败')
          }
        })
    },
    async handleSubmit () {
      this.overlay = true
      try {
        const obj = await this.$refs.edit.getValue()
        if (!obj) {
          return
        }
        await api.dataStandardAdd(obj)
        this.$snackbar.success('添加成功')
        this.show = false
        this.init()
      } catch (error) {
        this.$snackbar.error(error)
      } finally {
        this.overlay = false
      }
    },
    pageHandleChange (page) {
      this.pageInfo.current = page
      this.init()
    },
    handleSort (val) {
      this.orders = val
      this.init()
    }
  }
}
</script>

<style lang="scss" scoped>

</style>
